use std::{env, process};

//#[derive(Debug)]
struct Args {
    flags: Vec<char>,
    script: String,
    files: Vec<String>,
}

pub fn run() {
    let ret = get_args();
    println!("{:?} {:?} {:?}", ret.flags, ret.script, ret.files);
}

fn get_args() -> Args {
    let args: Vec<String> = env::args().skip(1).collect();
    let mut flags = Vec::new();
    let usage: &str = "Usage: ds -[vn](e|f) script files...";
    for (ind, item) in args.iter().enumerate() {
        if item.starts_with('-') {
            for (i, sw) in item.chars().skip(1).enumerate() {
                match sw {
                    'h' => {
                        println!("{}", usage);
                        process::exit(0);
                    }
                    'f' | 'e' => {
                        if i + 2 != item.len() {
                            eprintln!("-{} it is not last flag", sw);
                            process::exit(1);
                        }
                        let script = match args.get(ind + 1) {
                            None => {
                                eprintln!("not argument script");
                                process::exit(1);
                            }
                            Some(x) => x.to_owned(),
                        };
                        let files = match args.get(ind + 2..) {
                            //.unwrap_or(&[]).to_vec();
                            None | Some([]) => {
                                eprintln!("not argument files");
                                process::exit(1);
                            }
                            Some(x) => x.to_vec(),
                        };
                        flags.push(sw);
                        return Args {
                            flags,
                            script,
                            files,
                        };
                    }
                    x => flags.push(x),
                }
            }
        }
    }
    eprintln!("{}", usage);
    process::exit(1);
}
